CreateWorkflow
Creates a new workflow or a new version of an existing workflow. If a workflow with the same name and semantic version already exists, and your request changes its configuration, Image Builder creates a new build version. If the configuration is identical to the latest build version, the request fails because that workflow configuration already exists.
Request Syntax
PUT /CreateWorkflow HTTP/1.1
Content-type: application/json
{
"changeDescription": "string",
"clientToken": "string",
"data": "string",
"description": "string",
"dryRun": boolean,
"kmsKeyId": "string",
"name": "string",
"semanticVersion": "string",
"tags": {
"string" : "string"
},
"type": "string",
"uri": "string"
}
URI Request Parameters
The request does not use any URI parameters.
Request Body
The request accepts the following data in JSON format.
- changeDescription
-
Describes what change has been made in this version of the workflow, or what makes this version different from other versions of the workflow.
Type: String
Length Constraints: Minimum length of 1. Maximum length of 1024.
Required: No
- clientToken
-
A unique, case-sensitive identifier you provide to ensure that the operation runs no more than one time. If you retry a request with the same client token, Image Builder returns the original response without running the operation again. For more information, see Ensuring idempotency in the Amazon EC2 API Reference.
Type: String
Length Constraints: Minimum length of 1. Maximum length of 64.
Required: Yes
- data
-
The UTF-8 encoded YAML document content for the workflow, up to 16,000 characters. For larger documents, store the document in Amazon S3 and specify the
uriproperty instead. You must specify exactly one of thedataoruriproperties.Type: String
Length Constraints: Minimum length of 1. Maximum length of 16000.
Pattern:
[^\x00]+Required: No
- description
-
Describes the workflow.
Type: String
Length Constraints: Minimum length of 1. Maximum length of 1024.
Required: No
- dryRun
-
Validates the required permissions and request parameters without performing the operation. If validation succeeds, the operation returns a
DryRunOperationExceptionerror response.Type: Boolean
Required: No
- kmsKeyId
-
The Amazon Resource Name (ARN) that uniquely identifies the KMS key used to encrypt this workflow resource. This can be either the Key ARN or the Alias ARN. For more information, see Key identifiers (KeyId) in the AWS Key Management Service Developer Guide. If you don't specify a key, Image Builder encrypts the workflow document with a KMS key that Image Builder owns.
Type: String
Length Constraints: Minimum length of 1. Maximum length of 1024.
Required: No
- name
-
The name of the workflow to create. Image Builder generates the workflow ARN from a normalized form of the name, so names that differ only in case, spaces, or underscores count as the same name. If a workflow with the same name and semantic version already exists in your account in the same AWS Region, the request creates a new build version for it. If the content is also identical to the latest build version, the request fails because the workflow already exists.
Type: String
Pattern:
^[-_A-Za-z-0-9][-_A-Za-z0-9 ]{1,126}[-_A-Za-z-0-9]$Required: Yes
- semanticVersion
-
The semantic version of this workflow resource. The semantic version syntax adheres to the following rules.
Note
The semantic version has four nodes: <major>.<minor>.<patch>/<build>. You can assign values for the first three, and can filter on all of them.
Assignment: For the first three nodes, you can assign any positive integer value, including zero. The upper limit is 2^30-1, or 1073741823, for each node. Image Builder automatically assigns the build number to the fourth node.
Patterns: You can use any numeric pattern that adheres to the assignment requirements for the nodes that you can assign. For example, you might choose a software version pattern, such as 1.0.0, or a date, such as 2021.01.01.
Type: String
Pattern:
^[0-9]+\.[0-9]+\.[0-9]+$Required: Yes
-
Tags that apply to the workflow resource.
Type: String to string map
Map Entries: Maximum number of 50 items.
Key Length Constraints: Minimum length of 1. Maximum length of 128.
Key Pattern:
^(?!aws:)[a-zA-Z0-9\s_.:/=+\-@]*$Value Length Constraints: Maximum length of 256.
Required: No
- type
-
The image creation stage that this workflow applies to. Image Builder validates the workflow document steps against the stage you specify.
Type: String
Valid Values:
BUILD | TEST | DISTRIBUTIONRequired: Yes
- uri
-
The
uriof a YAML workflow document file stored in Amazon S3. This must be an S3 URL (s3://bucket/key), and you must have permission to access the S3 bucket it points to. A workflow document that you provide from Amazon S3 can be up to your service quota for workflow size.Alternatively, you can specify the YAML document inline, using the workflow
dataproperty. You must specify exactly one of thedataoruriproperties.Type: String
Required: No
Response Syntax
HTTP/1.1 200
Content-type: application/json
{
"clientToken": "string",
"latestVersionReferences": {
"latestMajorVersionArn": "string",
"latestMinorVersionArn": "string",
"latestPatchVersionArn": "string",
"latestVersionArn": "string"
},
"workflowBuildVersionArn": "string"
}
Response Elements
If the action is successful, the service sends back an HTTP 200 response.
The following data is returned in JSON format by the service.
- clientToken
-
The client token that uniquely identifies the request.
Type: String
Length Constraints: Minimum length of 1. Maximum length of 64.
- latestVersionReferences
-
A set of wildcard version ARNs that always reference the latest version of the resource. ARNs are included for the latest version overall, and for the latest versions within the same major, minor, and patch levels.
Type: LatestVersionReferences object
- workflowBuildVersionArn
-
The Amazon Resource Name (ARN) of the workflow resource that the request created.
Type: String
Length Constraints: Maximum length of 1024.
Pattern:
^arn:aws(?:-[a-z]+)*:imagebuilder:[a-z]{2,}(?:-[a-z]+)+-[0-9]+:(?:[0-9]{12}|aws(?:-[a-z-]+)?):workflow/(build|test|distribution)/[a-z0-9-_]+/[0-9]+\.[0-9]+\.[0-9]+/[0-9]+$
Errors
For information about the errors that are common to all actions, see Common Error Types.
- CallRateLimitExceededException
-
You have exceeded the permitted request rate for the Amazon EC2 APIs that Image Builder calls on your behalf. Retry with an increasing or variable delay between requests.
HTTP Status Code: 429
- ClientException
-
A generic client error. This error usually indicates that the request failed a validation check, such as when a downstream service rejects a configured value.
HTTP Status Code: 400
- DryRunOperationException
-
The dry run operation of the resource was successful, and no resources or mutations were actually performed due to the dry run flag in the request.
HTTP Status Code: 412
- ForbiddenException
-
You are not authorized to perform the requested operation.
HTTP Status Code: 403
- IdempotentParameterMismatchException
-
You have specified a client token for an operation using parameter values that differ from a previous request that used the same client token.
HTTP Status Code: 400
- InvalidParameterCombinationException
-
You have specified a combination of parameters that isn't valid. For example, two mutually exclusive parameters, or a parameter without its required companion parameter. Review the error message for details.
HTTP Status Code: 400
- InvalidRequestException
-
The request is malformed or otherwise invalid. Verify the request and try again.
HTTP Status Code: 400
- InvalidVersionNumberException
-
Your version number is out of bounds or does not follow the required syntax.
HTTP Status Code: 400
- ResourceInUseException
-
The resource that you are trying to operate on is currently in use. Review the message details and retry later.
HTTP Status Code: 400
- ServiceException
-
An internal server error occurred while Image Builder processed the request. Retrying the request may succeed.
HTTP Status Code: 500
- ServiceQuotaExceededException
-
You have exceeded the number of permitted resources or operations for this service. For service quotas, see EC2 Image Builder endpoints and quotas.
HTTP Status Code: 402
- ServiceUnavailableException
-
The service is unable to process your request at this time.
HTTP Status Code: 503
Examples
Create a build workflow from an inline document
The following example creates a build workflow from a YAML workflow document provided inline in the request.
Sample Request
PUT /CreateWorkflow HTTP/1.1
Content-type: application/json
{
"name": "my-example-workflow",
"semanticVersion": "1.0.0",
"description": "Workflow to build an AMI",
"type": "BUILD",
"data": "name: my-example-workflow\ndescription: Workflow to build an AMI\nschemaVersion: 1.0\nsteps:\n - name: LaunchBuildInstance\n action: LaunchInstance\n onFailure: Abort\n inputs:\n waitFor: ssmAgent\n - name: ApplyBuildComponents\n action: ExecuteComponents\n onFailure: Abort\n inputs:\n instanceId.$: $.stepOutputs.LaunchBuildInstance.instanceId\n - name: CreateOutputAMI\n action: CreateImage\n onFailure: Abort\n inputs:\n instanceId.$: $.stepOutputs.LaunchBuildInstance.instanceId\n - name: TerminateBuildInstance\n action: TerminateInstance\n onFailure: Continue\n inputs:\n instanceId.$: $.stepOutputs.LaunchBuildInstance.instanceId\n",
"clientToken": "a1b2c3d4-5678-90ab-cdef-EXAMPLE54321"
}
Sample Response
HTTP/1.1 200
Content-type: application/json
{
"clientToken": "a1b2c3d4-5678-90ab-cdef-EXAMPLE54321",
"workflowBuildVersionArn": "arn:aws:imagebuilder:us-west-2:111122223333:workflow/build/my-example-workflow/1.0.0/1",
"latestVersionReferences": {
"latestVersionArn": "arn:aws:imagebuilder:us-west-2:111122223333:workflow/build/my-example-workflow/x.x.x",
"latestMajorVersionArn": "arn:aws:imagebuilder:us-west-2:111122223333:workflow/build/my-example-workflow/1.x.x",
"latestMinorVersionArn": "arn:aws:imagebuilder:us-west-2:111122223333:workflow/build/my-example-workflow/1.0.x",
"latestPatchVersionArn": "arn:aws:imagebuilder:us-west-2:111122223333:workflow/build/my-example-workflow/1.0.0"
}
}
See Also
For more information about using this API in one of the language-specific AWS SDKs, see the following: